<?php

ini_set('display_errors', 1);

require_once '../../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources . "includes/connect.php";
require_once $base_path_to_learning_resources . "lib/function.php";
require_once $base_path_to_learning_resources . "lib/validate_api_signature.php";
require_once $base_path_to_learning_resources . "lib/validate_function.php";
require_once $base_path_to_learning . "user_management/authenticate.php";

require_once $base_path_to_learning_resources . "includes/specific_db_config.php";
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning . "vendor/autoload.php";
require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';
require_once $base_path_to_learning . "user_management/functions/functions.php";
require_once $base_path_to_learning . "admin_api/modules/library_management/library_function.php";
require_once $base_path_to_learning . "admin_api/modules/transportation/routes/routes_functions.php";



$postdata = json_decode(file_get_contents("php://input"), true);

checkIfNoPhpContentsReceive();

if (
    !isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id']) or
    !isset($postdata['bus_stop_id']) || !checkIfIssetAndNotEmpty($postdata['bus_stop_id']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type']) or
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['jwt_token']) or !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All fields are required.");
}

validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$branch_id = $jwt_validate->data->branch_id;
$institution_id = $jwt_validate->data->institution_id;


$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id, ["teacher"], $institution_id);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

require_once $base_path_to_learning . 'functions/common_functions.php';
require_once $base_path_to_learning . 'functions/get_branch_functions.php';
require_once $base_path_to_learning . 'user_management/user_versioning.php';

$version = isset($_POST['version']) ? $_POST['version'] : (isset($postdata['version']) ? $postdata['version'] : null);
$updated_time = isset($_POST['updated_time']) ? $_POST['updated_time'] : (isset($postdata['updated_time']) ? $postdata['updated_time'] : null);

$response = user_data_refresh($conn_rjllearning, $conn_rjllearning_specific,$version, $updated_time, $userid, $institution_id);

$academicSessionId = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
if (!$academicSessionId) {
    errorreturn("Invalid institution_id.");
}

function getspecific_bus_stop($conn_rjllearning_specific, $institution_id, $bus_stop_id) {
    $sql = $conn_rjllearning_specific->prepare("SELECT * FROM bus_stops WHERE id = ? AND institution_id = ?");
    $sql->execute([$bus_stop_id, $institution_id]);
    $result = $sql->fetch();

    if (!$result) {
        return false; // Return false if no result is found
    }
     $branch = getBranchInfo($conn_rjllearning_specific, $institution_id, $result['branch_id']);
    $success = [
        'institution_id' => $result['institution_id'],
        'stop_id' => $result['id'],
         'branch_id' => $branch,
        'stop_names' => $result['stop_names'],
        'proximity' => $result['proximity'],
        'charges' => $result['charges'],
    ];

    return $success;
}

if ($postdata['function_type'] == "fetch_specific_bus_stop") {
    if (!isset($postdata['bus_stop_id']) || empty(trim($postdata['bus_stop_id']))) {
        errorreturn("bus_stop_id is required.");
    }

    $bus_stop_id = trim($postdata['bus_stop_id']);

    $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
    if (!$check_academic_confirmation) {
        errorreturn("Access denied. Academic session not active.");
    }

    $fetch_routes = getspecific_bus_stop($conn_rjllearning_specific, $institution_id, $bus_stop_id);

    if ($fetch_routes) {
        successreturn($fetch_routes);
    } else {
        errorreturn("No route available.");
    }
} else {
    errorreturn("Invalid function_type.");
}


?>